
Core - Bug # 65667

Status: Resolved Priority: Must have
Author: Rob Pipe Category: Extbase
Created: 2015-03-11 Assigned To:
Updated: 2015-03-18 Due date:
TYPO3 Version: 6.2
PHP Version:
Complexity:
Is Regression: Yes
Sprint Focus:
Subject: ObjectManager can't resolve underscored namespace classes to new PHP's native namespace classes 

since TYPO3 6.2.10
Description

Since TYPO3 6.2.10 the class resolving from old namespace way with underscores seems to not work with the object manager/object
container anymore. This can lead to very strange problems, because the object manager instantiates singleton classes maybe twice.

Example: 

$persistenceManager1 =
$this->objectManager->get('TYPO3\CMS\Extbase\Persistence\Generic\PersistenceManagerInterface');
$persistenceManager2 = $this->objectManager->get('Tx_Extbase_Persistence_ManagerInterface');

// Since TYPO3 6.2.10 results in different hash values, because they are two different instances
var_dump(spl_object_hash($persistenceManager1));
var_dump(spl_object_hash($persistenceManager2));

// Thus since TYPO3 6.2.10 following comparison returns FALSE 
var_dump($persistenceManager1 === $persistenceManager2);

// Same behavior with another example class (here with object manager) 
$objectManager1 = $this->objectManager->get('Tx_Extbase_Object_ObjectManagerInterface');
$objectManager2 = $this->objectManager->get('TYPO3\CMS\Extbase\Object\ObjectManagerInterface');

var_dump(spl_object_hash($objectManager1));
var_dump(spl_object_hash($objectManager2));

var_dump($objectManager1 === $objectManager2); // Returns FALSE

Best regards, 
Rob

Related issues:
related to Core - Task # 64361: Improve class loading performance Resolved 2015-01-19

Associated revisions
Revision 89f9ec40 - 2015-03-14 20:46 - Helmut Hummel

[BUGFIX] Resolve class name from aliases managed by composer

2015-08-04 1/4



The old class loader has API to return the original class name
when given an alias. This API was not respected when implementing
composer class loading with #64361 with the result that it was
broken for all classes and aliases managed by the composer class loader.

To address this issue, the composer class loader is now injected into
the old class alias map, so that it can resolve class names from aliases
managed by it.

Related: #64361
Resolves: #65667
Releases: 6.2, master
Change-Id: If0b5098d72147fe7d76e97ee61c81d87cad72b4b
Reviewed-on: http://review.typo3.org/37825
Reviewed-by: Sascha Nowak <sascha.nowak@netlogix.de>
Tested-by: Sascha Nowak <sascha.nowak@netlogix.de>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Tested-by: Markus Klein <klein.t3@reelworx.at>

Revision cf02cd79 - 2015-03-18 11:13 - Helmut Hummel

[BUGFIX] Resolve class name from aliases managed by composer

The old class loader has API to return the original class name
when given an alias. This API was not respected when implementing
composer class loading with #64361 with the result that it was
broken for all classes and aliases managed by the composer class loader.

To address this issue, the composer class loader is now injected into
the old class alias map, so that it can resolve class names from aliases
managed by it.

Related: #64361
Resolves: #65667
Releases: 6.2, master
Change-Id: If0b5098d72147fe7d76e97ee61c81d87cad72b4b
Reviewed-on: http://review.typo3.org/37915
Reviewed-by: Helmut Hummel <helmut.hummel@typo3.org>
Reviewed-by: Markus Klein <klein.t3@reelworx.at>
Reviewed-by: Nicole Cordes <typo3@cordes.co>
Tested-by: Helmut Hummel <helmut.hummel@typo3.org>

History
#1 - 2015-03-11 15:46 - Markus Klein
- Status changed from New to Accepted
- Target version set to next-patchlevel
- Is Regression changed from No to Yes

Thanks for the report!
#2 - 2015-03-11 15:52 - Markus Klein

Bug in \TYPO3\CMS\Extbase\Object\Container\Container::getInstanceInternal()

No class alias maps available for Core classes. Seems to be related to: #64361

Another bug in the same function, IMO:
You can't instantiate
TYPO3\\CMS\\Extbase\\Object\\Container\\Container
TYPO3\\CMS\\Core\\Cache\\CacheManager
TYPO3\\CMS\\Core\\Package\\PackageManager

with the old name, because the resolution of aliases happens after the specific checks for those classes.

#3 - 2015-03-13 16:27 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37825

#4 - 2015-03-13 16:31 - Helmut Hummel

@Rob: can you please test if the fix works for you?

#5 - 2015-03-14 21:01 - Helmut Hummel
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:89f9ec40f033bb6fba4bfb7263313a16d78404de.

#6 - 2015-03-17 21:37 - Gerrit Code Review
- Status changed from Resolved to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37915

#7 - 2015-03-17 21:49 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at http://review.typo3.org/37915

#8 - 2015-03-18 11:30 - Helmut Hummel
- Status changed from Under Review to Resolved
Applied in changeset commit:cf02cd79bd0bf82afed268e3883425f327788f72.
